{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Uses Dos,Crt,Key;
Const
      PalMask = $36C;
      PalRegR = $3C7;
      PalRegW = $3C8;
      PalData = $3C9;

      St : Array[1..8] of string[40] =
(' ⮨  ண ⨩,',
 ' ᯠ   ३.',
 '  ⥡   ஦',
 '  㧥.',
 '    ᮫,',
 ',   ,',
 '⮡   諨 ࠦ',
 ' ᪨   .');

Type TPalette = Array[0..255] of record R,G,B : Byte; End;
     TFont = Array[0..255,1..8] of byte;

Var
DBuf : Pointer; { Double Buffer }
SegDB : Word;   { Segment of double-buffer }
Spr : Array[1..17] of Pointer; { Sprites }
SprW,SprH : Array[1..17] of LongInt;
Fnt : ^TFont;
Time : LongInt;
Timer : LongInt absolute $40:$6c;
X,Y,A,B,C,D,E : LongInt;
Lev,CatX,CatY : LongInt;
Mice : Array[1..1000] of record X,Y,Spd,ani : LongInt; End;
NM : LongInt;
Anim,Dir : LongInt;
Bo : Array[1..8,1..40] of Boolean;
bol1 : Boolean;
MC,MM : LongInt;
S : String;

{$L spr}
{$L fnt}
Procedure Sprites; far; external;
Procedure MyFont; far; external;

Function Sign(A : LongInt) : ShortInt;
Begin
  If A>0 then Sign:=1 else
    If A=0 then Sign:=0 else Sign:=-1;
End;

Procedure DrawSpriteD(Var Spr;x,y,w,h : Word); assembler;
Asm
  Mov ax,SegDB
  Mov es,ax
  Mov di,y
  Shl di,6
  Mov bx,di
  Shl di,2
  Add di,bx
  Add di,x
  push ds
  lds si,spr
  mov cx,h
@Me1 :
  push cx
  mov cx,w
@Me2 :
  Mov al,[si]
  Cmp al,0
  Je @Me3
  Mov es:[di],al
@Me3 :
  Inc di
  Inc si
  Loop @Me2
  pop cx
  add di,320
  sub di,w
  Loop @Me1
  Pop ds
End;

Procedure GrInit;
var a,b,c : longint;
s,o : Word;
Begin
  New(Fnt);
  S:=Seg(MyFont);
  O:=Ofs(MyFont);
  c:=0;
  For a:=128 to 239 do
    For b:=1 to 8 do
    Begin
      Fnt^[a,b]:=Mem[S:O+c];
      Inc(c);
    End;
  GetMem(DBuf,64000+16);
  SegDB:=Seg(DBuf^)+1;
  asm
    mov ax,13h
    int 10h
  end;
End;

Procedure GrDone;
Begin
  FreeMem(DBuf,64000+16);
  asm
    mov ax,3
    int 10h
  end;
End;

Procedure PixelD(x,y : Word;Color : Byte); assembler;
Asm
  Mov ax,SegDB
  Mov es,ax
  Mov di,y
  Shl di,6
  Mov bx,di
  Shl di,2
  Add di,bx
  Add di,x
  Mov al,Byte Ptr color
  Mov es : [di],al
End;

Procedure SetPalReg(index,Red,Green,Blue : Byte);
Begin
  Port[PalMask]:=$FF;
  Port[PalRegW]:=index;
  Port[PalData]:=Red;
  Port[PalData]:=Green;
  Port[PalData]:=Blue;
End;

Procedure GetPalReg(index : Byte; Var Red,Green,Blue : Byte);
Begin
  Port[PalMask]:=$FF;
  Port[PalRegR]:=index;
  Red:=Port[PalData];
  Green:=Port[PalData];
  Blue:=Port[PalData];
End;

Procedure ShowDouble; assembler;
Asm
  push ds
  Mov es,SegA000
  xor di,di
  Mov cx,32000
  Mov ds,SegDB
  xor si,si
  Cld
  Rep MovsW
  pop ds
End;

Procedure Cls(Color : Byte); assembler;
asm
  mov es,SegA000
  xor di,di
  mov al,Color
  mov ah,al
  mov cx,32000
  Cld
  rep stosw
End;

Procedure ClsD(Color : Byte); assembler;
asm
  mov es,SegDB
  xor di,di
  mov al,Color
  mov ah,al
  mov cx,32000
  Cld
  rep stosw
End;

Procedure PrintD(S : String;x,y : Word; color : Byte);
Var Segm,i,x1,y1,Off : Word;

  Procedure PrtD(Ch : Char;x,y,off : Word; color : Byte);
  Var WrkSeg,WrkOff,x2,y2,TOff : Word;
  BitMask,O : Byte;
  Begin
    If Ord(Ch)<128 then
    Begin
      TOff:=Off;
      WrkSeg:=$F000+(ord(Ch) shr 1);
      WrkOff:=$FA6E+((Ord(Ch) and 1) shl 3);
      For y:=0 to 7 do
      Begin
        BitMask:=$80;
        For x:=0 to 7 do
        Begin
          If Mem[WrkSeg:WrkOff] and BitMask<>0 then Mem[Segm:(TOff+x)]:=color;
{            else Mem[Segm:(TOff+x)]:=GetBack;}
          BitMask:=BitMask shr 1;
        End;
        Inc(TOff,320);
        Inc(WrkOff);
      End;
    End else
    Begin
      TOff:=Off;
      O:=Ord(CH);
      For y:=1 to 8 do
      Begin
        BitMask:=$80;
        For x:=0 to 7 do
        Begin
          If Fnt^[o,y] and BitMask<>0 then Mem[Segm:(TOff+x)]:=color;
{            else Mem[Segm:(TOff+x)]:=GetBack;}
          BitMask:=BitMask shr 1;
        End;
        Inc(TOff,320);
      End;
    End;
  End;

Begin
  x1:=x;y1:=y;
  Off:=(y shl 8)+(y shl 6)+x;
  Segm:=SegDB;
  For i:=1 to length(s) do
  Begin
    PrtD(s[i],x1,y1,off,color);
    Inc(x1,8);
    Inc(off,8);
  End;
End;

procedure VRT; assembler;
asm
  mov dx,3DAh
@VRT1:
  in al,dx
  test al,8
  jnz @VRT1
@VRT2:
  in al,dx
  test al,8
  jz @VRT2
end;

Procedure AddMouse(Spd : LongInt);
Begin
  Inc(NM);
  Mice[NM].x:=Random(302);
  Mice[NM].y:=0;
  Mice[NM].Spd:=Spd;
  Mice[NM].ani:=0;
End;

Procedure MouseCaught;
Var A,B,C : LongInt;
Begin
  C:=0;
  For A:=1 to 8 do
    For B:=1 to Length(St[A]) do
      If not Bo[A,B] then Inc(C);
  C:=Random(C)+1;
  For A:=1 to 8 do
    For B:=1 to Length(St[A]) do
      If not Bo[A,B] then
      Begin
        Dec(C);
        If C=0 then bo[A,B]:=True;
      End;
  Inc(MC);
  If MC mod 10=0 then Inc(lev);
End;

Procedure WorkM;
Begin
  For A:=1 to NM do
  Begin
    Inc(Mice[A].y,Mice[A].spd);
    Mice[A].ani:=1-Mice[A].ani;
    If (Mice[A].x>CatX-16) and (Mice[A].x<CatX+40) and
       (Mice[A].y>CatY-16) and (Mice[A].y<CatY+40) then
    Begin
      MouseCaught;
      mice[A].x:=Random(302);
      mice[A].y:=0;
    End;
    If (Mice[A].y>184) then
    Begin
      mice[A].x:=Random(302);
      mice[A].y:=0;
      Inc(MM);
    End;
  End;
  If NM<lev then AddMouse(lev div 2);
End;

Procedure WorkC;
Begin
  If Pressed[scLeft] then
  Begin
    If dir<>-1 then Begin dir:=-1; anim:=0; End else
    Begin
      Inc(anim);
      If anim>2 then anim:=0;
    End;
    Dec(CatX,5);
    If CatX<0 then
    Begin
      CatX:=0;
      dir:=-2;
    End;
  End;
  If Pressed[scRight] then
  Begin
    If dir<>1 then Begin dir:=1; anim:=0; End else
    Begin
      Inc(anim);
      If anim>2 then anim:=0;
    End;
    Inc(CatX,5);
    If CatX>280 then
    Begin
      CatX:=280;
      dir:=2;
    End;
  End;
  If ((dir=1) or (dir=-1)) and not Pressed[scLeft] and not Pressed[scRight] then
    dir:=dir*2;
End;

Begin
  Randomize;
  GrInit;
  Cls(0);
  B:=Seg(Sprites);
  C:=Ofs(Sprites);
  For A:=1 to 17 do
  Begin
    SprW[A]:=MemL[B:C];
    SprH[A]:=MemL[B:C+4];
    Spr[A]:=Ptr(B,C+8);
    Inc(C,8+SprW[A]*SprH[A]);
  End;
  FillChar(Bo,SizeOf(Bo),True);
  For A:=1 to 8 do
    For B:=1 to Length(St[A]) do
      If St[A,B]<>' ' then Bo[A,B]:=False;
  SetPalReg(15,$0,$0,$0);
  AddMouse(1);
  Lev:=2;
  Install_Handler;
  Dir:=0;Anim:=0;
  CatX:=150;
  CatY:=90;
  MC:=0;
  Repeat
    Time:=Timer;
    ClsD(1);
    Case Dir of
    -1:A:=9+Anim;
    1:A:=12+Anim;
    0:A:=15;
    2:A:=17;
    -2:A:=16;
    End;
    DrawSpriteD(Spr[A]^,CatX,CatY,SprW[A],SprH[A]);
    bol1:=True;
    For A:=1 to 8 do
      For B:=1 to Length(St[A]) do
        If Bo[A,B] then PrintD(St[A,B],B*8+30,A*8+123,13) else bol1:=False;
    If bol1 then Break;
    For A:=1 to NM do
      DrawSpriteD(Spr[1+Mice[A].ani]^,mice[A].x,mice[A].y,16,16);
    WorkM;
    WorkC;
    Str(MC,S);
    PrintD(' 襩: '+S,0,0,3);
    Str(MM,S);
    PrintD('ய饭 襩: '+S,160,0,3);
    VRT;
    Repeat Until Timer-Time>0;
    ShowDouble;
  Until Pressed[scEsc];
  If bol1 then
  Begin
    ClsD(1);
    A:=15;
    DrawSpriteD(Spr[A]^,CatX,CatY,SprW[A],SprH[A]);
    For A:=1 to 8 do
      PrintD(St[A],38,A*8+123,13);
    Str(MC,S);
    PrintD(' 襩: '+S,0,0,3);
    Str(MM,S);
    PrintD('ய饭 襩: '+S,160,0,3);
    ShowDouble;
    Repeat Until not Pressed[scEsc];
    Repeat Until Pressed[scEnter] or Pressed[scSpace] or Pressed[scEsc];
    Repeat Until not Pressed[scEnter] and not Pressed[scSpace] and not Pressed[scEsc];
  End;
  Restore_Handler;
  GrDone;
End.